'use strict';var Vue=require('vue'),FreeDraw=require('leaflet-freedraw'),vue2Leaflet=require('vue2-leaflet'),lodashEs=require('lodash-es'),leaflet=require('leaflet');function _interopDefaultLegacy(e){return e&&typeof e==='object'&&'default'in e?e:{'default':e}}var Vue__default=/*#__PURE__*/_interopDefaultLegacy(Vue);var FreeDraw__default=/*#__PURE__*/_interopDefaultLegacy(FreeDraw);function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}function withNonReactive(data) {
  return function () {
    return data;
  };
}

function validateMode(mode) {
  switch (mode) {
    case FreeDraw.NONE:
      return true;

    case FreeDraw.CREATE:
      return true;

    case FreeDraw.DELETE:
      return true;

    case FreeDraw.EDIT:
      return true;

    case FreeDraw.APPEND:
      return true;

    case FreeDraw.EDIT_APPEND:
      return true;

    case FreeDraw.ALL:
      return true;

    default:
      return false;
  }
}

var props = {
  options: {
    type: Object,
    default: function _default() {
      return {};
    }
  },
  mode: {
    type: Number,
    default: FreeDraw.ALL,
    custom: true,
    validator: function validator(value) {
      return validateMode(value);
    }
  },
  value: {
    type: Array,
    custom: true,
    default: function _default() {
      return [];
    }
  },
  debounce: {
    type: Boolean,
    default: true,
    custom: true
  }
};
var script = Vue__default['default'].extend({
  name: 'LFreeDraw',
  props: props,
  data: function data() {
    return withNonReactive({
      ready: false,
      lastSetPolygons: []
    })();
  },
  mounted: function mounted() {
    var _this = this;

    var noParent = 'l-freedraw needs to be a children or grand children of a l-map object';

    if (this.$parent) {
      this.mapObject = new FreeDraw__default['default'](_objectSpread2(_objectSpread2({}, this.options), {}, {
        mode: this.mode
      }));
      leaflet.DomEvent.on(this.mapObject, this.$listeners);
      vue2Leaflet.propsBinder(this, this.mapObject, props);
      var debouncedHandler = lodashEs.debounce(this.markerHandler, 100);

      if (this.debounce) {
        this.mapObject.on('markers', debouncedHandler);
      } else {
        this.mapObject.on('markers', this.markerHandler);
      }

      this.parentContainer = vue2Leaflet.findRealParent(this.$parent);

      if (this.parentContainer) {
        this.parentContainer.addLayer(this);
        this.setValue(this.value);
        this.ready = true;
        this.$nextTick(function () {
          _this.$emit('ready', _this.mapObject);
        });
      } else {
        throw new Error(noParent);
      }
    } else {
      throw new Error(noParent);
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.mapObject) {
      this.mapObject.off('markers');
      leaflet.DomEvent.off(this.mapObject, this.$listeners);
      this.mapObject.clear();
      this.setMode(FreeDraw.NONE);

      if (this.parentContainer) {
        this.parentContainer.removeLayer(this);
      }
    }
  },
  methods: {
    setValue: function setValue(newPolygons) {
      var _this2 = this;

      if (!newPolygons) {
        this.lastSetPolygons = [];

        if (this.mapObject) {
          this.mapObject.clear();
        }
      } else if (!lodashEs.isEqual(newPolygons, this.lastSetPolygons)) {
        this.lastSetPolygons = newPolygons;

        if (this.mapObject) {
          this.mapObject.clear();
          newPolygons.forEach(function (polygon) {
            return _this2.mapObject && _this2.mapObject.create(polygon);
          });
        }
      }
    },
    markerHandler: function markerHandler(event) {
      this.$emit('input', event.latLngs);
      this.lastSetPolygons = event.latLngs;
    },
    setMode: function setMode(mode) {
      if (!validateMode(mode)) {
        throw new Error('Invalid mode');
      } else if (this.mapObject) {
        this.mapObject.mode(mode);
      }
    },
    setDebounce: function setDebounce(value) {
      if (this.mapObject) {
        if (value) {
          this.mapObject.off('markers');
          var debouncedHandler = lodashEs.debounce(this.markerHandler, 100);
          this.mapObject.on('markers', debouncedHandler);
        } else {
          this.mapObject.off('markers');
          this.mapObject.on('markers', this.markerHandler);
        }
      }
    }
  }
  /* setup(setupProps, { parent, emit, listeners }) {
    const ready = ref(false);
    function calculateMode(active: boolean) {
      if (active) {
        return ALL;
      }
      return NONE;
    }
     const instance = getCurrentInstance();
    const mergedOptions = computed<Partial<FreeDrawOptions>>(() => {
      const option = {
        mode: calculateMode(setupProps.active),
      };
      if (instance) {
        return optionsMerger(option, instance.proxy);
      }
      return option;
    });
     const mapObject = markRaw(new FreeDraw(mergedOptions.value));
     let lastSetPolygons: LatLng[][] = [];
    function setActive(active: boolean) {
      if (mapObject) {
        mapObject.mode(calculateMode(active));
      }
    }
    function setPolygons(newPolygons: LatLng[][]) {
      if (!newPolygons) {
        lastSetPolygons = [];
        if (mapObject) {
          mapObject.clear();
        }
      } else if (!isEqual(newPolygons, lastSetPolygons)) {
        lastSetPolygons = newPolygons;
        if (mapObject) {
          mapObject.clear();
          newPolygons.forEach(
            (polygon) => mapObject && mapObject.create(polygon),
          );
        }
      }
    }
     function markerHandler(event: MarkerEvent) {
      emit('update:polygons', event.latLngs);
      lastSetPolygons = event.latLngs;
    }
     const debouncedHandler = debounce(markerHandler, 100);
    let parentContainer: LLayerGroup;
     onMounted(() => {
      if (instance && parent) {
        type propsType = Parameters<typeof propsBinder>;
        propsBinder(instance.proxy, mapObject, props);
        ready.value = true;
        parentContainer = findRealParent(parent);
        parentContainer.addLayer(instance.proxy);
        setPolygons(setupProps.polygons);
        mapObject.on('markers', debouncedHandler);
        DomEvent.on(
          (mapObject as unknown) as HTMLElement,
          listeners as eventMap,
        );
      }
    });
     onBeforeUnmount(() => {
      if (mapObject) {
        mapObject.off('markers');
        DomEvent.off(
          (mapObject as unknown) as HTMLElement,
          listeners as eventMap,
        );
        mapObject.clear();
        setActive(false);
        if (instance) {
          parentContainer.removeLayer(instance.proxy);
        }
      }
    });
     return {
      calculateMode,
      ready,
      mapObject,
      setPolygons,
      setActive,
    };
  }, */

});function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', []);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = undefined;
/* scoped */

var __vue_scope_id__ = undefined;
/* module identifier */

var __vue_module_identifier__ = "data-v-7f473ed0";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);// Import vue component

// Default export is installable instance of component.
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),
var component = /* #__PURE__ */(function () {
  // Assign InstallableComponent type
  var installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = function (Vue) {
    Vue.component('LFreedraw', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default': component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;